@echo off
echo ____________________________________________________________________
echo      _   _                          _                               
echo     //  //                          /              /         ,      
echo ---/ / /-/-----__-----__-----__----/--------__----/__-----------_/_-
echo   /  //  /   /___)  /   )  /   )  /       /   )  /   )     /    /   
echo _/___ ___/__(___ __(___/__(___(__/____/__(___(__(___/__o__/____(_ __
echo                      /                                             
echo                  (_ / 
echo.
echo ------------------------ www.MegaLab.it -----------------------------
echo.

rem Dettagli (da personalizzare) inerenti il server REMOTO
SET server_remoto_username=root
SET server_remoto_indirizzo=servermysql.miodominio.com

SET mysql_remoto_username=root
SET mysql_remoto_password=miapasswordremota
SET mysql_comando_dump_remoto=/usr/local/mysql/bin/mysqldump
SET mysql_quali_database_dumpare=miodatabase1 miodatabase2 miodatabase3

SET percorso_remoto_di_appoggio=/usr/backup/
SET comando_di_cancellazione_remoto=rm -f
SET sevenzip_comando_remoto=/usr/local/bin/7z


rem Dettagli (da personalizzare) inerenti il server LOCALE
SET mysql_locale_indirizzo=localhost
SET mysql_locale_username=root
SET mysql_locale_password=miapasswordlocale
SET mysql_locale_comando=C:\Programmi\MySQL\bin\mysql.exe

SET percorso_locale_di_appoggio=C:\Users\Zane\Documents\
SET comando_di_cancellazione_locale=del /Q /F
SET sevenzip_comando_locale=C:\Programmi\7-Zip\7z.exe


rem ---------------------------------------------------------------------------------
rem Sezione operativa - Da qua in poi non dovrebbe essere necessario modificare nulla!
rem ---------------------------------------------------------------------------------
rem ---------------------------------------------------------------------------------
cd %~dp0
 %~d0

if not EXIST "%percorso_locale_di_appoggio%dump_database_mysql.7z" goto nodel
echo Elimino la copia locale..
%comando_di_cancellazione_locale% "%percorso_locale_di_appoggio%dump_database_mysql.7z"
:nodel

echo Dump del database remoto..
ssh %server_remoto_username%@%server_remoto_indirizzo% "%mysql_comando_dump_remoto% -u\"%mysql_remoto_username%\" -p\"%mysql_remoto_password%\" --opt --add-drop-database --lock-all-tables --databases %mysql_quali_database_dumpare% > \"%percorso_remoto_di_appoggio%dump_database_mysql.sql\""

echo Compressione del database appena dumpato..
ssh %server_remoto_username%@%server_remoto_indirizzo% "\"%sevenzip_comando_remoto%\" a -t7z -mx=7 \"%percorso_remoto_di_appoggio%dump_database_mysql.7z\" \"%percorso_remoto_di_appoggio%dump_database_mysql.sql\""

echo Elimino il dump remoto del database..
ssh %server_remoto_username%@%server_remoto_indirizzo% "%comando_di_cancellazione_remoto% \"%percorso_remoto_di_appoggio%dump_database_mysql.sql\""


echo Trasferisco il database compresso in locale..
SET cygpath=%percorso_locale_di_appoggio:\=/%
SET cygpath=%cygpath::=%
scp %server_remoto_username%@%server_remoto_indirizzo%:"%percorso_remoto_di_appoggio%dump_database_mysql.7z" "/cygdrive/%cygpath%dump_database_mysql.7z"

echo Elimino il database compresso remoto..
ssh %server_remoto_username%@%server_remoto_indirizzo% "%comando_di_cancellazione_remoto% \"%percorso_remoto_di_appoggio%dump_database_mysql.7z\""

echo Scompatto il database compresso..
"%sevenzip_comando_locale%" e "%percorso_locale_di_appoggio%dump_database_mysql.7z" -o"%percorso_locale_di_appoggio%" -y

echo Importazione del database dal dump..
"%mysql_locale_comando%" -h%mysql_locale_indirizzo% -u"%mysql_locale_username%" -p"%mysql_locale_password%" < "%percorso_locale_di_appoggio%\dump_database_mysql.sql"

echo Elimino la copia scompattata del dump..
%comando_di_cancellazione_locale% "%percorso_locale_di_appoggio%dump_database_mysql.sql"